// KeckControllerDlg.cpp : implementation file
//

#include "stdafx.h"
#include "KeckController.h"
#include "KeckControllerDlg.h"
#include "KeckSockets.h"

#ifdef _DEBUG
#define new DEBUG_NEW
#undef THIS_FILE
static char THIS_FILE[] = __FILE__;
#endif

#define STRLEN 80        // string size for general text manipulation   
char str[STRLEN];        // global string for general text manipulation 

#define SHOW_ERROR(ecode) ::MessageBox(HWND_DESKTOP,olDaGetErrorString(ecode,\
                  str,STRLEN),"Error", MB_ICONEXCLAMATION | MB_OK);

#define CHECKERROR(ecode) if ((status = (ecode)) != OLNOERROR)\
                  {\
                  SHOW_ERROR(status);\
                  olDaReleaseDASS(ct_ss);\
                  olDaTerminate(hdrvr);\
                  return 0;}

#define CHECKERROR2(ecode) if ((status = (ecode)) != OLNOERROR)\
                  {\
                  SHOW_ERROR(status);\
                  olDaReleaseDASS(ct_ss);\
                  olDaTerminate(hdrvr);\
                  }

#define NUM_PCS 1
#define NUM_CAMERAS_PER_PC 3

/////////////////////////////////////////////////////////////////////////////
// CAboutDlg dialog used for App About

class CAboutDlg : public CDialog
{
public:
	CAboutDlg();

// Dialog Data
	//{{AFX_DATA(CAboutDlg)
	enum { IDD = IDD_ABOUTBOX };
	//}}AFX_DATA

	// ClassWizard generated virtual function overrides
	//{{AFX_VIRTUAL(CAboutDlg)
	protected:
	virtual void DoDataExchange(CDataExchange* pDX);    // DDX/DDV support
	//}}AFX_VIRTUAL

// Implementation
protected:
	//{{AFX_MSG(CAboutDlg)
	//}}AFX_MSG
	DECLARE_MESSAGE_MAP()
};

CAboutDlg::CAboutDlg() : CDialog(CAboutDlg::IDD)
{
	//{{AFX_DATA_INIT(CAboutDlg)
	//}}AFX_DATA_INIT
}

void CAboutDlg::DoDataExchange(CDataExchange* pDX)
{
	CDialog::DoDataExchange(pDX);
	//{{AFX_DATA_MAP(CAboutDlg)
	//}}AFX_DATA_MAP
}

BEGIN_MESSAGE_MAP(CAboutDlg, CDialog)
	//{{AFX_MSG_MAP(CAboutDlg)
		// No message handlers
	//}}AFX_MSG_MAP
END_MESSAGE_MAP()

/////////////////////////////////////////////////////////////////////////////
// CKeckControllerDlg dialog

CKeckControllerDlg::CKeckControllerDlg(CWnd* pParent /*=NULL*/)
	: CDialog(CKeckControllerDlg::IDD, pParent)
{
	//{{AFX_DATA_INIT(CKeckControllerDlg)
	m_frameRate = 0;
	m_numFramesToCapture = 0;
	m_pauseBeforeCapture = FALSE;
	m_pauseTime = 0;
	//}}AFX_DATA_INIT
	// Note that LoadIcon does not require a subsequent DestroyIcon in Win32
	m_hIcon = AfxGetApp()->LoadIcon(IDR_MAINFRAME);
}

void CKeckControllerDlg::DoDataExchange(CDataExchange* pDX)
{
	CDialog::DoDataExchange(pDX);
	//{{AFX_DATA_MAP(CKeckControllerDlg)
	DDX_Control(pDX, IDC_CAPTURE, m_capture);
	DDX_Control(pDX, IDC_MESSAGES, m_messages);
	DDX_Control(pDX, IDC_CAMERAS, m_cameras);
	DDX_Text(pDX, IDC_FRAME_RATE, m_frameRate);
	DDX_Text(pDX, IDC_EDIT2, m_numFramesToCapture);
	DDX_Check(pDX, IDC_PAUSE_BEFORE_CAPTURE, m_pauseBeforeCapture);
	DDX_Text(pDX, IDC_PAUSE_TIME, m_pauseTime);
	//}}AFX_DATA_MAP
}

BEGIN_MESSAGE_MAP(CKeckControllerDlg, CDialog)
	//{{AFX_MSG_MAP(CKeckControllerDlg)
	ON_WM_SYSCOMMAND()
	ON_WM_PAINT()
	ON_WM_QUERYDRAGICON()
	ON_BN_CLICKED(IDC_CAPTURE, OnCapture)
	ON_WM_DESTROY()
	ON_BN_CLICKED(IDC_SAVE, OnSave)
	ON_BN_CLICKED(IDC_DISPLAY, OnDisplay)
	ON_BN_CLICKED(IDC_PLAY, OnPlay)
	//}}AFX_MSG_MAP
END_MESSAGE_MAP()

/////////////////////////////////////////////////////////////////////////////
// CKeckControllerDlg message handlers

BOOL CKeckControllerDlg::OnInitDialog()
{
	CDialog::OnInitDialog();

	// Add "About..." menu item to system menu.

	// IDM_ABOUTBOX must be in the system command range.
	ASSERT((IDM_ABOUTBOX & 0xFFF0) == IDM_ABOUTBOX);
	ASSERT(IDM_ABOUTBOX < 0xF000);

	CMenu* pSysMenu = GetSystemMenu(FALSE);
	if (pSysMenu != NULL)
	{
		CString strAboutMenu;
		strAboutMenu.LoadString(IDS_ABOUTBOX);
		if (!strAboutMenu.IsEmpty())
		{
			pSysMenu->AppendMenu(MF_SEPARATOR);
			pSysMenu->AppendMenu(MF_STRING, IDM_ABOUTBOX, strAboutMenu);
		}
	}

	// Set the icon for this dialog.  The framework does this automatically
	//  when the application's main window is not a dialog
	SetIcon(m_hIcon, TRUE);			// Set big icon
	SetIcon(m_hIcon, FALSE);		// Set small icon
	
	// read defaults
	m_frameRate = AfxGetApp()->GetProfileInt("KeckController", "m_frameRate", 30);
	m_numFramesToCapture = AfxGetApp()->GetProfileInt("KeckController", "m_numFramesToCapture", 1);
	m_pauseBeforeCapture = AfxGetApp()->GetProfileInt("KeckController", "m_pauseBeforeCapture", 1);
	m_pauseTime = AfxGetApp()->GetProfileInt("KeckController", "m_pauseTime", 0);
	UpdateData(FALSE);

	// Get first available Open Layers board 
	CHECKERROR (olDaInitialize("Board1", &hdrvr));

	// get handle to CT sub system 
	CHECKERROR (olDaGetDASS(hdrvr, OLSS_CT, 4, &ct_ss));
	CHECKERROR (olDaGetDASS(hdrvr, OLSS_CT, 6, &ct_ss2));

	// setup internally cascaded clock
	olDaSetCascadeMode(ct_ss, OL_CT_CASCADE);
	olDaSetCascadeMode(ct_ss2, OL_CT_CASCADE);

	// specify internal CT clock input source
	CHECKERROR (olDaSetClockSource(ct_ss, OL_CLK_INTERNAL));
	CHECKERROR (olDaSetClockSource(ct_ss2, OL_CLK_INTERNAL));

	// specify gate type
	CHECKERROR (olDaSetGateType(ct_ss, OL_GATE_NONE));
	CHECKERROR (olDaSetGateType(ct_ss2, OL_GATE_NONE));

	// specify frequency of CT clock output
	CHECKERROR (olDaSetClockFrequency(ct_ss, (double)m_frameRate));
	CHECKERROR (olDaSetClockFrequency(ct_ss2, (double)m_frameRate));

	// setup for rate generation
	CHECKERROR (olDaSetCTMode(ct_ss, OL_CTMODE_RATE));
	CHECKERROR (olDaSetCTMode(ct_ss2, OL_CTMODE_RATE));

	// specify polarity of output pulses
	CHECKERROR (olDaSetPulseType(ct_ss, OL_PLS_HIGH2LOW));
	CHECKERROR (olDaSetPulseType(ct_ss2, OL_PLS_HIGH2LOW));

	// specify pulse width
	CHECKERROR (olDaSetPulseWidth(ct_ss, 95.00));
	CHECKERROR (olDaSetPulseWidth(ct_ss2, 95.00));

	// configure the system
	CHECKERROR (olDaConfig(ct_ss));
	CHECKERROR (olDaConfig(ct_ss2));

	// setup cameras
//	setupCameraList();

	return TRUE;  // return TRUE  unless you set the focus to a control
}

void CKeckControllerDlg::OnSysCommand(UINT nID, LPARAM lParam)
{
	if ((nID & 0xFFF0) == IDM_ABOUTBOX)
	{
		CAboutDlg dlgAbout;
		dlgAbout.DoModal();
	}
	else
	{
		CDialog::OnSysCommand(nID, lParam);
	}
}

// If you add a minimize button to your dialog, you will need the code below
//  to draw the icon.  For MFC applications using the document/view model,
//  this is automatically done for you by the framework.

void CKeckControllerDlg::OnPaint() 
{
	if (IsIconic())
	{
		CPaintDC dc(this); // device context for painting

		SendMessage(WM_ICONERASEBKGND, (WPARAM) dc.GetSafeHdc(), 0);

		// Center icon in client rectangle
		int cxIcon = GetSystemMetrics(SM_CXICON);
		int cyIcon = GetSystemMetrics(SM_CYICON);
		CRect rect;
		GetClientRect(&rect);
		int x = (rect.Width() - cxIcon + 1) / 2;
		int y = (rect.Height() - cyIcon + 1) / 2;

		// Draw the icon
		dc.DrawIcon(x, y, m_hIcon);
	}
	else
	{
		CDialog::OnPaint();
	}
}

// The system calls this to obtain the cursor to display while the user drags
//  the minimized window.
HCURSOR CKeckControllerDlg::OnQueryDragIcon()
{
	return (HCURSOR) m_hIcon;
}

void CKeckControllerDlg::OnCapture() 
{
	UpdateData(TRUE);


	CString s;
	m_capture.GetWindowText(s);
	if (s == "Capture") {
		m_capture.SetWindowText("Stop");

		if (m_pauseBeforeCapture) {
			Sleep(m_pauseTime * 1000);
		}
		Beep(1000, 1000);
		AddMessage("Capturing...");

		// specify frequency of CT clock output
//		CHECKERROR2 (olDaSetClockFrequency(ct_ss, (double)m_frameRate));

		// start signal generator
		CHECKERROR2 (olDaStart(ct_ss));
		CHECKERROR2 (olDaStart(ct_ss2));
	} else {
		m_capture.SetWindowText("Capture");

		AddMessage("Stop.");

		// stop signal generator
		CHECKERROR2 (olDaStop(ct_ss));
		CHECKERROR2 (olDaStop(ct_ss2));
	}

#if 0
	// connect to PCs and start capture
	CString dcfFile = "c:\\genesis\\dcf\\kodak\\es-310\\es310_30.dcf";
	for (int i = 0; i < NUM_PCS; i++) {
		// create the SOCKET 
		client[i].Create();

		// seek a connection 
		CString address;
		address.Format("keck%02d.umiacs.umd.edu", i);
		if (!client[i].Connect(address, SOCKET_PORT)) {
			CString error;
			error.FormatMessage(GetLastError());
			AddMessage("Could not connect to 'keck%d': %s", i, error);
			continue;
		}

		// construct file object 
		CSocketFile file(&client[i]);

		// construct an archive
		CArchive arOut(&file, CArchive::store);

		// start capture
		for (int c = 0; c < NUM_CAMERAS_PER_PC; c++) {
			arOut << MT_START_CAPTURE;
			arOut << m_numFramesToCapture;
			arOut << dcfFile;
			arOut << c;
		}
	}
#endif
}

void CKeckControllerDlg::OnDestroy() 
{
	UpdateData(TRUE);
	AfxGetApp()->WriteProfileInt("KeckController", "m_frameRate", m_frameRate);
	AfxGetApp()->WriteProfileInt("KeckController", "m_numFramesToCapture", m_numFramesToCapture);
	AfxGetApp()->WriteProfileInt("KeckController", "m_pauseBeforeCapture", m_pauseBeforeCapture);
	AfxGetApp()->WriteProfileInt("KeckController", "m_pauseTime", m_pauseTime);

	olDaTerminate(hdrvr);

	CDialog::OnDestroy();
}

// append the printf style message to the m_messagesList listbox
void CKeckControllerDlg::AddMessage(char *fmt, ...)
{
	va_list args;   
	va_start(args, fmt);
	CString str;
	str.FormatV(fmt, args);
	int k = m_messages.AddString(str);
	m_messages.SetCurSel(k);
	va_end(args);
}


void CKeckControllerDlg::OnSave() 
{
	// TODO: Add your control notification handler code here
	
}

void CKeckControllerDlg::OnDisplay() 
{
	// TODO: Add your control notification handler code here
	
}

void CKeckControllerDlg::OnPlay() 
{
	// TODO: Add your control notification handler code here
	
}

CString GetLastErrorMessage()
{
	LPVOID lpMsgBuf;
	FormatMessage( 
		FORMAT_MESSAGE_ALLOCATE_BUFFER | FORMAT_MESSAGE_FROM_SYSTEM,
		NULL,
		GetLastError(),
		MAKELANGID(LANG_NEUTRAL, SUBLANG_DEFAULT), // Default language
		(LPTSTR) &lpMsgBuf,
		0,
		NULL 
	);
	CString error = (char *)lpMsgBuf;
	LocalFree( lpMsgBuf );
	return error;
}

void CKeckControllerDlg::setupCameraList()
{
	CArray<CSocket, CSocket &> client;
	client.SetSize(NUM_PCS);
	CString dcfFile = "c:\\genesis\\dcf\\kodak\\es-310\\es310_30.dcf";
	for (int i = 0; i < NUM_PCS; i++) {
		// create the SOCKET 
		client[i].Create();

		// seek a connection 
		CString address;
		address.Format("keck%02d.umiacs.umd.edu", i);
		if (!client[i].Connect(address, SOCKET_PORT)) {
//			CString error;
//			error.FormatMessage(GetLastError());
			AddMessage("Could not connect to 'keck%d': %s", i, GetLastErrorMessage());
			continue;
		}
		
		for (int c = 0; c < NUM_CAMERAS_PER_PC; c++) {
			CString str;
			int n = i * NUM_CAMERAS_PER_PC + c;
			str.Format("Keck%02d: camera %d", i, n);
			m_cameras.AddString(str);
			m_cameras.SetCheck(n, TRUE);
		}
	}
}
